/******************************************************************************
*@Q[pw֘A֐Q
******************************************************************************/
#include "inc.h"
#include "div_arm.h"
#include "math_arm.h"

/* Opf[^ */
s16 m_costbl[] = {
       256        /* no.  0 */
    ,  255        /* no.  1 */
    ,  255        /* no.  2 */
    ,  255        /* no.  3 */
    ,  254        /* no.  4 */
    ,  254        /* no.  5 */
    ,  253        /* no.  6 */
    ,  252        /* no.  7 */
    ,  251        /* no.  8 */
    ,  249        /* no.  9 */
    ,  248        /* no. 10 */
    ,  246        /* no. 11 */
    ,  244        /* no. 12 */
    ,  243        /* no. 13 */
    ,  241        /* no. 14 */
    ,  238        /* no. 15 */
    ,  236        /* no. 16 */
    ,  234        /* no. 17 */
    ,  231        /* no. 18 */
    ,  228        /* no. 19 */
    ,  225        /* no. 20 */
    ,  222        /* no. 21 */
    ,  219        /* no. 22 */
    ,  216        /* no. 23 */
    ,  212        /* no. 24 */
    ,  209        /* no. 25 */
    ,  205        /* no. 26 */
    ,  201        /* no. 27 */
    ,  197        /* no. 28 */
    ,  193        /* no. 29 */
    ,  189        /* no. 30 */
    ,  185        /* no. 31 */
    ,  181        /* no. 32 */
    ,  176        /* no. 33 */
    ,  171        /* no. 34 */
    ,  167        /* no. 35 */
    ,  162        /* no. 36 */
    ,  157        /* no. 37 */
    ,  152        /* no. 38 */
    ,  147        /* no. 39 */
    ,  142        /* no. 40 */
    ,  136        /* no. 41 */
    ,  131        /* no. 42 */
    ,  126        /* no. 43 */
    ,  120        /* no. 44 */
    ,  115        /* no. 45 */
    ,  109        /* no. 46 */
    ,  103        /* no. 47 */
    ,   97        /* no. 48 */
    ,   92        /* no. 49 */
    ,   86        /* no. 50 */
    ,   80        /* no. 51 */
    ,   74        /* no. 52 */
    ,   68        /* no. 53 */
    ,   62        /* no. 54 */
    ,   56        /* no. 55 */
    ,   49        /* no. 56 */
    ,   43        /* no. 57 */
    ,   37        /* no. 58 */
    ,   31        /* no. 59 */
    ,   25        /* no. 60 */
    ,   18        /* no. 61 */
    ,   12        /* no. 62 */
    ,    6        /* no. 63 */
    ,    0        /* no. 64 */
    ,   -6        /* no. 65 */
    ,  -12        /* no. 66 */
    ,  -18        /* no. 67 */
    ,  -25        /* no. 68 */
    ,  -31        /* no. 69 */
    ,  -37        /* no. 70 */
    ,  -43        /* no. 71 */
    ,  -49        /* no. 72 */
    ,  -56        /* no. 73 */
    ,  -62        /* no. 74 */
    ,  -68        /* no. 75 */
    ,  -74        /* no. 76 */
    ,  -80        /* no. 77 */
    ,  -86        /* no. 78 */
    ,  -92        /* no. 79 */
    ,  -97        /* no. 80 */
    , -103        /* no. 81 */
    , -109        /* no. 82 */
    , -115        /* no. 83 */
    , -120        /* no. 84 */
    , -126        /* no. 85 */
    , -131        /* no. 86 */
    , -136        /* no. 87 */
    , -142        /* no. 88 */
    , -147        /* no. 89 */
    , -152        /* no. 90 */
    , -157        /* no. 91 */
    , -162        /* no. 92 */
    , -167        /* no. 93 */
    , -171        /* no. 94 */
    , -176        /* no. 95 */
    , -181        /* no. 96 */
    , -185        /* no. 97 */
    , -189        /* no. 98 */
    , -193        /* no. 99 */
    , -197        /* no.100 */
    , -201        /* no.101 */
    , -205        /* no.102 */
    , -209        /* no.103 */
    , -212        /* no.104 */
    , -216        /* no.105 */
    , -219        /* no.106 */
    , -222        /* no.107 */
    , -225        /* no.108 */
    , -228        /* no.109 */
    , -231        /* no.110 */
    , -234        /* no.111 */
    , -236        /* no.112 */
    , -238        /* no.113 */
    , -241        /* no.114 */
    , -243        /* no.115 */
    , -244        /* no.116 */
    , -246        /* no.117 */
    , -248        /* no.118 */
    , -249        /* no.119 */
    , -251        /* no.120 */
    , -252        /* no.121 */
    , -253        /* no.122 */
    , -254        /* no.123 */
    , -254        /* no.124 */
    , -255        /* no.125 */
    , -255        /* no.126 */
    , -255        /* no.127 */
    , -256        /* no.128 */
    , -255        /* no.129 */
    , -255        /* no.130 */
    , -255        /* no.131 */
    , -254        /* no.132 */
    , -254        /* no.133 */
    , -253        /* no.134 */
    , -252        /* no.135 */
    , -251        /* no.136 */
    , -249        /* no.137 */
    , -248        /* no.138 */
    , -246        /* no.139 */
    , -244        /* no.140 */
    , -243        /* no.141 */
    , -241        /* no.142 */
    , -238        /* no.143 */
    , -236        /* no.144 */
    , -234        /* no.145 */
    , -231        /* no.146 */
    , -228        /* no.147 */
    , -225        /* no.148 */
    , -222        /* no.149 */
    , -219        /* no.150 */
    , -216        /* no.151 */
    , -212        /* no.152 */
    , -209        /* no.153 */
    , -205        /* no.154 */
    , -201        /* no.155 */
    , -197        /* no.156 */
    , -193        /* no.157 */
    , -189        /* no.158 */
    , -185        /* no.159 */
    , -181        /* no.160 */
    , -176        /* no.161 */
    , -171        /* no.162 */
    , -167        /* no.163 */
    , -162        /* no.164 */
    , -157        /* no.165 */
    , -152        /* no.166 */
    , -147        /* no.167 */
    , -142        /* no.168 */
    , -136        /* no.169 */
    , -131        /* no.170 */
    , -126        /* no.171 */
    , -120        /* no.172 */
    , -115        /* no.173 */
    , -109        /* no.174 */
    , -103        /* no.175 */
    ,  -97        /* no.176 */
    ,  -92        /* no.177 */
    ,  -86        /* no.178 */
    ,  -80        /* no.179 */
    ,  -74        /* no.180 */
    ,  -68        /* no.181 */
    ,  -62        /* no.182 */
    ,  -56        /* no.183 */
    ,  -49        /* no.184 */
    ,  -43        /* no.185 */
    ,  -37        /* no.186 */
    ,  -31        /* no.187 */
    ,  -25        /* no.188 */
    ,  -18        /* no.189 */
    ,  -12        /* no.190 */
    ,   -6        /* no.191 */
    ,    0        /* no.192 */
    ,    6        /* no.193 */
    ,   12        /* no.194 */
    ,   18        /* no.195 */
    ,   25        /* no.196 */
    ,   31        /* no.197 */
    ,   37        /* no.198 */
    ,   43        /* no.199 */
    ,   49        /* no.200 */
    ,   56        /* no.201 */
    ,   62        /* no.202 */
    ,   68        /* no.203 */
    ,   74        /* no.204 */
    ,   80        /* no.205 */
    ,   86        /* no.206 */
    ,   92        /* no.207 */
    ,   97        /* no.208 */
    ,  103        /* no.209 */
    ,  109        /* no.210 */
    ,  115        /* no.211 */
    ,  120        /* no.212 */
    ,  126        /* no.213 */
    ,  131        /* no.214 */
    ,  136        /* no.215 */
    ,  142        /* no.216 */
    ,  147        /* no.217 */
    ,  152        /* no.218 */
    ,  157        /* no.219 */
    ,  162        /* no.220 */
    ,  167        /* no.221 */
    ,  171        /* no.222 */
    ,  176        /* no.223 */
    ,  181        /* no.224 */
    ,  185        /* no.225 */
    ,  189        /* no.226 */
    ,  193        /* no.227 */
    ,  197        /* no.228 */
    ,  201        /* no.229 */
    ,  205        /* no.230 */
    ,  209        /* no.231 */
    ,  212        /* no.232 */
    ,  216        /* no.233 */
    ,  219        /* no.234 */
    ,  222        /* no.235 */
    ,  225        /* no.236 */
    ,  228        /* no.237 */
    ,  231        /* no.238 */
    ,  234        /* no.239 */
    ,  236        /* no.240 */
    ,  238        /* no.241 */
    ,  241        /* no.242 */
    ,  243        /* no.243 */
    ,  244        /* no.244 */
    ,  246        /* no.245 */
    ,  248        /* no.246 */
    ,  249        /* no.247 */
    ,  251        /* no.248 */
    ,  252        /* no.249 */
    ,  253        /* no.250 */
    ,  254        /* no.251 */
    ,  254        /* no.252 */
    ,  255        /* no.253 */
    ,  255        /* no.254 */
    ,  255        /* no.255 */
};

/* tڃe[u */
u8 m_Atntbl[] = {
	   0,  0,  0,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2,  3	/* No.   0` 15 */
	,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5	/* No.  16` 31 */
	,  5,  5,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  7,  7,  8	/* No.  32` 47 */
	,  8,  8,  8,  8,  8,  8,  9,  9,  9,  9,  9,  9, 10, 10, 10, 10	/* No.  48` 63 */
	, 10, 10, 10, 11, 11, 11, 11, 11, 11, 11, 12, 12, 12, 12, 12, 12	/* No.  64` 79 */
	, 12, 13, 13, 13, 13, 13, 13, 13, 14, 14, 14, 14, 14, 14, 14, 15	/* No.  80` 95 */
	, 15, 15, 15, 15, 15, 15, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17	/* No.  96`111 */
	, 17, 17, 17, 17, 17, 18, 18, 18, 18, 18, 18, 18, 19, 19, 19, 19	/* No. 112`127 */
	, 19, 19, 19, 19, 20, 20, 20, 20, 20, 20, 20, 20, 21, 21, 21, 21	/* No. 128`143 */
	, 21, 21, 21, 21, 21, 22, 22, 22, 22, 22, 22, 22, 22, 23, 23, 23	/* No. 144`159 */
	, 23, 23, 23, 23, 23, 23, 24, 24, 24, 24, 24, 24, 24, 24, 24, 25	/* No. 160`175 */
	, 25, 25, 25, 25, 25, 25, 25, 25, 25, 26, 26, 26, 26, 26, 26, 26	/* No. 176`191 */
	, 26, 26, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 28, 28, 28, 28	/* No. 192`207 */
	, 28, 28, 28, 28, 28, 28, 28, 29, 29, 29, 29, 29, 29, 29, 29, 29	/* No. 208`223 */
	, 29, 29, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 31, 31, 31	/* No. 224`239 */
	, 31, 31, 31, 31, 31, 31, 31, 31, 31, 32, 32, 32, 32, 32, 32, 32	/* No. 240`255 */
	, 32
};



/*=============================================================================
/	Qbg(256x)
/------------------------------------------------------------------------------
/	Param
/		dx, dy = S̋(0`255)
/	Return
/		GetAngle = 0 ` 255
/                        192
/                     128 { 0
/                         64
/============================================================================*/
IWRAM_CODE u8 GetAngle(s16 dx, s16 dy)
{
    u8  a;
    u16 adx, ady;
    u16 z;

	if((dx!=0)||(dy!=0)){						/* ʒułȂƂ */
		adx = dx;								/* Βl߂ */
		ady = dy;
		if(dx < 0)   adx = -adx;
		if(dy < 0)   ady = -ady;

	    if(adx > ady){							/* XY̑召r */
	        z = _UDiv((ady<<8), adx);			/* XY̔߂ */
			a = m_Atntbl[z];
		}else{
			z = _UDiv((adx<<8), ady);			/* YX̔߂ */
			a = 64 - m_Atntbl[z];
		}
		if(dx < 0)  a = 128 - a;			    /* ubNɂĕ𒲐 */
		if(dy < 0)  a = 256 - a;

	}else{
		a = 64;									/* ʒûƂ͐^ */
	}
	return a;
}
