
/******************************************************************************
*	Ge
******************************************************************************/
#define bullet_width 1
#define bullet_height 1

#define BULLET_FONTENT		160
#define BULLET_FONTS		(bullet_width * bullet_height)

unsigned short bmp_bullet[] = {
	0x1818, 0x7E66, 0x665A, 0xC3BD, 0xC3BD, 0x665A, 0x7E66, 0x1818
};

/* Ge\ */
typedef struct{
	short			use;
    POS 			pos;
    short			vx, vy;
    unsigned char 	angle;
    short 			speed;
}BULLET;


/*-----------------------------------------------------------------------------
*  ^XN
*----------------------------------------------------------------------------*/
void tsk_bullet(TSKWRK *tp)
{
	BULLET *w = (BULLET*)&tp->wrk[0];

	switch(tp->phase){
	/*---------------------------------------------------*/
	case P_INIT:
		tp->phase = P_MAIN;
		break;

	/*---------------------------------------------------*/
	case P_MAIN:
		/* ړ */
	    w->X += w->vx;
	    w->Y += w->vy;

		/* ړ͈͗} */
		if(w->XH < 0 || w->XH > SCR_XH
		|| w->YH < 0 || w->YH > SCR_YH){
			tp->phase = P_END;
			break;
		}

		/* XvCgo^ */
  		SetSpr( w->XH, w->YH, SPR_ATTR(BULLET_FONTENT+0, 12, 1));

		break;

	/*---------------------------------------------------*/
	case P_END:
		DelTsk(tp);
		break;
	}
}

/*=============================================================================
/  Ge
/------------------------------------------------------------------------------
/	Param
/		x, y     = JnWisNZj
/		speed    = exisNZ^t[j
/		angle    = Jn(0`255F_̍@+256FŒ)
/		way      = WAY(0`255)
/		vangle   = A[`̕(0`255)
/============================================================================*/
void Fire( unsigned char x
		 , unsigned char y
		 , int speed
		 , int angle
		 , unsigned int way
		 , int vangle )
{
	TSKWRK			*tp;
	BULLET			*w;
	unsigned char	ap;		/* ˕ */
	int				va;		/* eWay̒SZbg邽߂̕ϐ */
	int				i;
	
	if(angle < 256){		/* 0`255̎A_ */
		angle = (GetAngle(pMyship->XH-x, pMyship->YH-y) + angle) & 0xff;
	}
	else{					/* 256ȏ̂Ƃ́A-256̌ŒɌ */
		angle -= 256;
	}

	if((way & 1) == 0){		/* WAY̎ */
		angle -= vangle/2;	/* SJ悤ɂ */
	}
	
	ap = angle;
	va = vangle;
	
	for( i=way; i>=1; i-- ){
		/* o^ */
		tp = SetTsk(tsk_bullet);
		w = (BULLET*)&tp->wrk[0];
		w->vx = SQR_VX(ap, speed);
		w->vy = SQR_VY(ap, speed);
		w->XH  = x;
		w->YH  = y;
		
		/* ] */
		ap += va;						/* ő256𒴂Ȃ悤ɂ */
		vangle = -vangle;				/* WayLĂ䂭 */
		va = -va + vangle;				/* ̒e̕ɐڂ */
	}
}

