/******************************************************************************
*
*  @֘A
*
******************************************************************************/

/*=============================================================================
/	@̒e
/============================================================================*/
#define shot_width 1
#define shot_height 1

#define SHOT_FONTENT		144
#define SHOT_FONTS			(ship_width * ship_height)

unsigned short bmp_shot[] = {
	0xFEFE, 0x92FE, 0x92FE, 0x92FE, 0xFE92, 0xFE92, 0xFE92, 0xFEFE, 
};

/*-----------------------------------------------------------------------------
*  ^XN
*----------------------------------------------------------------------------*/
void tsk_myshot(TSKWRK *tp)
{
	MYSHOT *w = (MYSHOT*)&tp->wrk[0];

	switch(tp->phase){
	/*---------------------------------------------------*/
	case P_INIT:
		tp->phase = P_MAIN;
		break;

	/*---------------------------------------------------*/
	case P_MAIN:
	    w->X += w->vx;
	    w->Y += w->vy;

		/* ړ͈͗} */
		if(w->XH < 0 || w->XH > SCR_XH
		|| w->YH < 0 || w->YH > SCR_YH){
			tp->phase = P_END;
			break;
		}
		
		/* XvCgo^ */
		SetSpr( w->XH, w->YH, SPR_ATTR(SHOT_FONTENT+0, 12, 1));

		break;

	/*---------------------------------------------------*/
	case P_END:
		DelTsk(tp);
		break;
	}
}
/*-----------------------------------------------------------------------------
*  
*----------------------------------------------------------------------------*/
void set_myshot(short x, short y)
{
	TSKWRK *tp;
	MYSHOT *w;
	static unsigned char shot_dir[] = {192, 192+6, 192-6, 192+12, 192-12};
	int i;
	
	for(i=0; i<5; i++){		/* Ɏˏo */
		tp = SetTsk(tsk_myshot);
		w = (MYSHOT*)&tp->wrk[0];
		w->X = x;
		w->Y = y;
		w->speed = 1024;
		w->angle = shot_dir[i];
		w->vx = SQR_VX(w->angle, w->speed);
		w->vy = SQR_VY(w->angle, w->speed);
	}
}


/*=============================================================================
/	@
/============================================================================*/
#define ship_width 2
#define ship_height 2

#define SHIP_FONTENT		128
#define SHIP_FONTS			(ship_width * ship_height)

unsigned short bmp_ship[] = {
	0x0101, 0x0203, 0x0203, 0x1A1B, 0x2B3A, 0x2B3A, 0x3F37, 0x2A3F, 
	0x8080, 0xC040, 0xC040, 0xD858, 0xD45C, 0xDC54, 0xFCE4, 0x5CF4, 
	0x2A3F, 0x3F2A, 0x7F7B, 0xFFAE, 0xFFAA, 0xEFFF, 0x3E3E, 0x0808, 
	0x7CD4, 0xFC5C, 0xFEDE, 0xFF75, 0xFF55, 0xF7FF, 0x7C7C, 0x1010, 
};
MYSHIP *pMyship;       /* ̂ւ̃|C^ */

/*-----------------------------------------------------------------------------
*  ^XN
*----------------------------------------------------------------------------*/
void tsk_myship(TSKWRK *tp)
{
	MYSHIP *w = (MYSHIP*)&tp->wrk[0];

	switch(tp->phase){
	/*---------------------------------------------------*/
	case P_INIT:
		w->XH = SCR_XH/2;
		w->YH = 144-32;
		w->speed = 256;
		tp->phase = P_MAIN;
		break;

	/*---------------------------------------------------*/
	case P_MAIN:
		/* X{^ɂړ */
		w->vx = w->vy = 0;
		if     (g_key & KEY_X2)		w->vx =  w->speed;
		else if(g_key & KEY_X4)		w->vx = -w->speed;
		if     (g_key & KEY_X1)		w->vy = -w->speed;
		else if(g_key & KEY_X3)		w->vy =  w->speed;
	    w->X += w->vx;
	    w->Y += w->vy;

		/* ړ͈͗} */
		if(w->XH <        12)		w->XH = 12;
		if(w->XH > SCR_XH-12)		w->XH = SCR_XH-12;
		if(w->YH <        12)		w->YH = 12;
		if(w->YH > SCR_YH-12)		w->YH = SCR_YH-12;
			
		/* A{^ɂe(I[gA) */
		if(w->rapidcnt==0){
			if(g_key & KEY_A){
				set_myshot(w->X, w->Y);
				w->rapidcnt = 7;
			}
		}else{
			--w->rapidcnt;
		}
		
		/* XvCgo^ */
  		SetSpr( w->XH-4, w->YH-4, SPR_ATTR(SHIP_FONTENT+0, 12, 1));
  		SetSpr( w->XH+4, w->YH-4, SPR_ATTR(SHIP_FONTENT+1, 12, 1));
  		SetSpr( w->XH-4, w->YH+4, SPR_ATTR(SHIP_FONTENT+2, 12, 1));
  		SetSpr( w->XH+4, w->YH+4, SPR_ATTR(SHIP_FONTENT+3, 12, 1));

		break;

	/*---------------------------------------------------*/
	case P_END:
		DelTsk(tp);
		break;
	}
}
/*-----------------------------------------------------------------------------
*  
*----------------------------------------------------------------------------*/
TSKWRK *set_myship(void)
{
	TSKWRK *tp;
	tp = SetTsk(tsk_myship);
	pMyship = (MYSHIP*)&tp->wrk[0];

	return tp;
}
