/*****************************************************************************/
/*                                                                           */
/*  ȈՃXvCgVXe for WonderWitch                                   */
/* -------------------------------------------------                         */
/*                                                                           */
/*                                                       2000 2001 ނ  */
/*                                                                           */
/*****************************************************************************/

#include <sys/bios.h>
#include "def.h"
#include "sprite.h"

#define		MAXSPR	128

typedef struct{
	unsigned short	attr;
	unsigned char	y;
	unsigned char	x;
}SPRWRK;

static SPRWRK	m_spr[MAXSPR];
static int		m_sprites;

/*=============================================================================
/  XvCg
/-----------------------------------------------------------------------------
/===========================================================================*/
void IniSpr(void)
{
	m_sprites = 0;
}


/*=============================================================================
/  XvCgo^
/-----------------------------------------------------------------------------
/===========================================================================*/
void SetSpr(unsigned char x, unsigned char y, unsigned short attr)
{
	if(m_sprites < MAXSPR){							/* 128ȓ͏ɓo^ */
		m_spr[m_sprites].attr = attr;
		m_spr[m_sprites].y = (unsigned char)(y-8);
		m_spr[m_sprites].x = (unsigned char)(x-8);
		++m_sprites;
	}
}

/*=============================================================================
/  XvCg\
/-----------------------------------------------------------------------------
/=============================================================================*/
void PutSpr(void)
{
	int spr = m_sprites;
	
	if(spr > MAXSPR){
		spr = MAXSPR;
	}
	sprite_set_range(0, spr);
	sprite_set_data(0, spr, &m_spr[0]);
}

/*=============================================================================
/  XvCg擾
/-----------------------------------------------------------------------------
/=============================================================================*/
int GetSprites(void)
{
	return m_sprites;
}
